require 'fileutils'
require 'pty'
require 'open-uri'
require 'mustache'
require 'thor'
require 'traveler/util'

module Traveler
  extend Util

  BUCKET_ROOT = 'https://traveling-ruby.s3-us-west-2.amazonaws.com/'.freeze
  RELEASES_URL = 'http://d6r77u77i8pq3.cloudfront.net/releases/'.freeze

  PWD = Dir.pwd.freeze
  SKEL_PATH = File.expand_path('../../skel', __FILE__).freeze

  CONFIGFILE = 'Travelfile'.freeze
  CONFIGFILE_PATH = File.join(PWD, CONFIGFILE).freeze
  CONFIGFILE_SKEL = skeldir(CONFIGFILE).freeze

  GEMFILE = 'Gemfile'.freeze
  GEMFILE_PATH = File.join(PWD, GEMFILE)
  GEMFILE_SKEL = skeldir(GEMFILE)

  RUBY_VERSIONS = %w[
    2.1.5
    2.2.0
  ].freeze

  TRAVELING_RUBY_VERSIONS = %w[
    20150210
    20150210
    20150204
  ].freeze

  PLATFORMS = %w[
    linux-x86
    linux-x86_64
    osx
  ].freeze

  OPTED_PLATFORMS = []
  WRAPPERS = {}

  SIGNATURE = <<-STR.unindent.strip.freeze
  # ================================================================= #
  # Autogenerated by Traveler. Any updates will be lost on next build #
  # ================================================================= #
  STR

  SUCCESS_ICONS = %w[
    10004   128515  128516  128522
    128523  128540  127866  128079
    128076  128077  128175  128176
    127853  127942  128640  127919
  ].map {|c| [c.to_i].pack('U*')}.freeze
end
